package org.gcube.portlets.user.databasesmanager.client;

import java.util.LinkedHashMap;
import java.util.List;

import org.gcube.portlets.user.databasesmanager.client.datamodel.FileModel;
import org.gcube.portlets.user.databasesmanager.client.datamodel.Result;
import org.gcube.portlets.user.databasesmanager.client.datamodel.Row;

//import org.gcube.portlets.user.dbmanager.client.datamodel.FileModel;
//import org.gcube.portlets.user.dbmanager.client.datamodel.Result;
//import org.gcube.portlets.user.dbmanager.client.datamodel.Row;

import com.google.gwt.user.client.rpc.RemoteService;
import com.google.gwt.user.client.rpc.RemoteServiceRelativePath;

//interface that defines RPC methods
@RemoteServiceRelativePath("dbManagerService")
public interface GWTdbManagerService extends RemoteService {

	List<FileModel> getResource() throws Exception;

	List<FileModel> getTables(LinkedHashMap<String, String> dataInput)
			throws Exception;

	LinkedHashMap<String, FileModel> getDBInfo(String resourceName)
			throws Exception;

	List<FileModel> getDBSchema(LinkedHashMap<String, String> dataInput)
			throws Exception;

	List<Result> submitQuery(LinkedHashMap<String, String> dataDB,
			String query, boolean valueReadOnlyQuery,
			boolean smartCorrectionQuery, String language) throws Exception;

	List<Row> parseCVSString(List<Result> result, List<String> attrNames)
			throws Exception;

}
