package org.gcube.portlets.user.databasesmanager.client;

import java.util.LinkedHashMap;
import java.util.List;

import org.gcube.portlets.user.databasesmanager.client.datamodel.FileModel;
import org.gcube.portlets.user.databasesmanager.client.datamodel.Result;
import org.gcube.portlets.user.databasesmanager.client.datamodel.Row;

//import org.gcube.portlets.user.dbmanager.client.datamodel.FileModel;
//import org.gcube.portlets.user.dbmanager.client.datamodel.Result;
//import org.gcube.portlets.user.dbmanager.client.datamodel.Row;

import com.google.gwt.user.client.rpc.AsyncCallback;

public interface GWTdbManagerServiceAsync {

	void getResource(AsyncCallback<List<FileModel>> asyncCallback);

	void getDBInfo(String resourceName,
			AsyncCallback<LinkedHashMap<String, FileModel>> asyncCallback);

	void getTables(LinkedHashMap<String, String> dataInput,
			AsyncCallback<List<FileModel>> callback);

	void getDBSchema(LinkedHashMap<String, String> dataInput,
			AsyncCallback<List<FileModel>> callback);

	void submitQuery(LinkedHashMap<String, String> dataDB, String query,
			boolean valueReadOnlyQuery, boolean smartCorrectionQuery,
			String language, AsyncCallback<List<Result>> callback);

	void parseCVSString(List<Result> result, List<String> attrNames,
			AsyncCallback<List<Row>> callback);

}
