package org.gcube.portlets.user.databasesmanager.client.datamodel;

import java.io.Serializable;
import java.util.List;

import com.extjs.gxt.ui.client.data.BaseModelData;

public class FileModel extends BaseModelData implements Serializable {

	private static final long serialVersionUID = 1L;

	private static int ID = 0;
	// private int id;
	private boolean isExpanded = true;
	// private boolean isSchema = false;
	private boolean isLoaded = false;
	// private boolean isTable = false;
	private boolean isDatabase = false;


	private List<Result> DBInfo = null;
	private boolean isDBInfoDisplayed = false;

	public FileModel() {
		setId();
		// setIsExpanded(true);
		// setIsSchema(false);
	}

	public FileModel(String name) {
		setName(name);
		setId();

	}

	public void setId() {
		set("ID", this.ID++);
	}

	public int getId() {
		return get("ID");

	}

	public void setName(String name) {
		set("name", name);
	}

	public String getName() {
		return get("name");
	}

	public void setIsExpanded(boolean value) {

		isExpanded = value;
	}

	public boolean isExpanded() {

		return isExpanded;
	}

	public void setIsLoaded(boolean value) {

		isLoaded = value;

	}

	public boolean isLoaded() {

		return isLoaded;

	}

	public void setIsSchema(boolean value) {

		set("isSchema", value);
	}

	public boolean isSchema() {
		return get("isSchema");
	}

	public void setIsTable(boolean value) {

		set("isTable", value);
	}

	public boolean isTable() {

		return get("isTable");
	}

	public void setIsDatabase(boolean value) {

		isDatabase = value;
	}

	public boolean isDatabase() {

		return isDatabase;
	}

	public void setDBInfo(List<Result> data) {
		DBInfo = data;
	}

	public List<Result> getDBInfo() {
		return DBInfo;
	}

	public void setIsDBInfoDisplayed(boolean value) {
		isDBInfoDisplayed = value;
	}

	public boolean isDBInfoDisplayed() {
		return isDBInfoDisplayed;
	}

	@Override
	public boolean equals(Object obj) {
		if (obj != null && obj instanceof FileModel) {
			FileModel mobj = (FileModel) obj;
			return getName().equals(mobj.getName());
		}
		return super.equals(obj);
	}

}